% \documentclass[noanswers, nolegalese, 11pt]{examjh}
\documentclass[answers, nolegalese, 11pt]{examjh}
\usepackage{../../../../computingfonts}
\usepackage{../../../../contentmacros}
\usepackage{../../../../grammar}

\setlength{\parindent}{0em}\setlength{\parskip}{0.5ex}
\pagestyle{empty}
\begin{document}\thispagestyle{empty}
\makebox[\textwidth]{Questions for Three.II\hfill  From \textit{Theory of Computation}, by Hef{}feron}\vspace{-1ex}
\makebox[\textwidth]{\hbox{}\hrulefill\hbox{}}


\begin{questions}
\question
Use this grammar.
\begin{grammar}
  \ntrm{natural} \produces{} \ntrm{digit} 
        \syntaxor \ntrm{digit}\ntrm{natural}   
  
  \ntrm{digit} \produces{} \trm{0} \syntaxor \trm{1} \syntaxor \trm{2} \syntaxor \trm{3} \syntaxor \trm{4} \syntaxor \trm{5} \syntaxor \trm{6} \syntaxor \trm{7} \syntaxor \trm{8} \syntaxor \trm{9}
\end{grammar}
\begin{parts}
\part What is the alphabet?
  What are the terminals?
  The nonterminals?
  What is the start symbol?
\begin{solution}
The alphabet is $\Sigma=\set{\str{0},\ldots{} \str{9}}$.
The terminals are \str{0}, \ldots{} \str{9}.
The nonterminals are \synt{natural} and \synt{digit}.
The start symbol is \synt{natural}.
\end{solution}

\part For each production, name the head and the body.
\begin{solution}
For the production 
\begin{grammar}
  \ntrm{natural} \produces{} \ntrm{digit} 
\end{grammar}
the head is \synt{natural} while the body is \synt{digit}.
For the production  
\begin{grammar}
  \ntrm{natural} \produces{} \ntrm{digit}\ntrm{natural}   
\end{grammar}
the head is \synt{natural} while the body is \synt{digit}\synt{digit}.
For the production  
\begin{grammar}
  \ntrm{digit} \produces{} \trm{0}
\end{grammar}
the head is \synt{digit} and the body is \str{0}.
The remaining eight productions are similar.
\end{solution}

\part Which are the metacharacters that are used?
\begin{solution}
The two metacharacters are \produces{} and \syntaxor.
\end{solution}

\part Derive \str{42}.
\begin{solution}
\begin{center}
  \begin{tabular}{r@{}l}
    \ntrm{natural}
    &\derives\ntrm{digit}\ntrm{natural}              \\
    &\derives\trm{4}\ntrm{natural}              \\
    &\derives\trm{4}\ntrm{digit}              \\
    &\derives\trm{4}\trm{2} 
  \end{tabular}
\end{center}
\end{solution}

\part Give its derivation tree.
\begin{solution}
\begin{center}
  \includegraphics{asy/languages000.pdf}
\end{center}
\end{solution}

\part \str{993}
\begin{solution}
\begin{center}
  \begin{tabular}{r@{}l}
    \ntrm{natural}
    &\derives\ntrm{digit}\ntrm{natural}              \\
    &\derives\ntrm{digit}\ntrm{digit}\ntrm{natural}              \\
    &\derives\ntrm{digit}\ntrm{digit}\ntrm{digit}              \\
    &\derives\ntrm{digit}\trm{9}\ntrm{digit}              \\
    &\derives\ntrm{digit}\trm{9}\trm{3}              \\
    &\derives\trm{9}\trm{9}\trm{3}              
  \end{tabular}
\end{center}
\end{solution}

\part Give its tree.
\begin{solution}
\begin{center}
  \includegraphics{asy/languages001.pdf}
\end{center}
\end{solution}

\part How can \synt{natural} be defined in terms of \synt{natural}?
  Doesn't that lead to infinite regress?
\begin{solution}
We want to start at the start symbol and end at the desired string.
Just willy-nilly expanding is not the game.
\end{solution}
\end{parts}


\question
Consider again the grammar in the prior exercise.
\begin{parts}
\part
Extend it to cover the integers.
\part
Can you derive \str{+0}?  \str{-0}?
\end{parts}

\question
Use this grammar.
\begin{grammar}
\ntrm{expr} \produces{} \ntrm{term} \trm{+} \ntrm{expr} \syntaxor \ntrm{term}

\ntrm{term} \produces{} \ntrm{term} \trm{*} \ntrm{factor} \syntaxor \ntrm{factor}

\ntrm{factor} \produces \trm{(} \ntrm{expr} \trm{)} \syntaxor 
  \trm{a} \syntaxor \trm{b} \syntaxor \ldots{} \syntaxor \trm{z}
\end{grammar}
\begin{parts}
\part Derive \str{(a+b)*c}.
Give the derivation tree.
\part Derive \str{(a+b)*(c+d)}.
Give the derivation tree.
\end{parts}


\question
Use this grammar.
\begin{grammar}
S \produces aABb

A \produces aA \syntaxor a

B \produces Bb \syntaxor b
\end{grammar}
\begin{parts}
\part Derive three strings.
\begin{solution}
Here are the derivations of \str{aabb},
  \begin{display}
  \begin{tabular}[t]{l}
    S\derives  \trm{a}AB\trm{b}
     \derives \trm{a}\trm{a}B\trm{b}
     \derives \trm{a}\trm{a}\trm{b}\trm{b}
  \end{tabular}
  \end{display}
  of \str{aaabb},
  \begin{display}
  \begin{tabular}[t]{l}
    S\derives  \trm{a}AB\trm{b}
     \derives \trm{a}\trm{a}AB\trm{b}
     \derives \trm{a}\trm{a}\trm{a}B\trm{b}
     \derives \trm{a}\trm{a}\trm{b}\trm{b}
  \end{tabular}
  \end{display}
  and of \str{aabbb}
  \begin{display}
  \begin{tabular}[t]{l}
    S\derives  \trm{a}AB\trm{b}
     \derives \trm{a}AB\trm{b}
     \derives \trm{a}\trm{a}B\trm{b}
     \derives \trm{a}\trm{a}B\trm{b}\trm{b}
     \derives \trm{a}\trm{a}\trm{b}\trm{b}\trm{b}
  \end{tabular}
  \end{display}
\end{solution}

\part Name three strings over $\Sigma=\set{\str{a},\str{b}}$ that are not
  derivable. 
\begin{solution}
The production starting with the start symbol~S shows that every
derived string must begin with~\trm{a} and end with~\str{b}.
So three strings that cannot be derived are \str{a}, \str{ba}, 
and~\emptystring{} (the empty string).  
\end{solution}

\part Describe the language generated by this grammar.
\begin{solution}
$\lang=\set{\str{a}^n\str{b}^m\suchthat n,m\geq 2}$
\end{solution}
\end{parts}

\question
Give a grammar for the language $\set{\str{a}^n\str{b}^{n+m}\str{a}^m\suchthat n,m\in\N}$.
\begin{solution}
Here is one.
\begin{grammar}
  S \produces{} TU

  T \produces{} \trm{a}T\trm{b} \syntaxor \emptystring{}

  U \produces{} \trm{b}U\trm{a} \syntaxor \emptystring{}  
\end{grammar}
\end{solution}
\end{questions}
\end{document}
